﻿<!-- [QPRTemplateStart: quickfilter.tpl] -->

<script type="text/javascript" src="<#CommonScriptFileLocation>jquery-ui.js"></script>
<link type="text/css" href="<#CSSFileLocation>jquery-ui.css" rel="stylesheet" />

<script type="text/javascript">

/***********************/
/* USER SETTINGS START */
/***********************/

// All the columns were a date filter should be applied to
var DATE_FIELDS = ["createddate", "lastmodifieddate", "approveddate", "startdate", "deadline", "identified", "validfrom", "validto", "datestamp"];

// All the columns where a quick filter is not needed
var BLACKLIST_FIELDS = ["measure.rangevalue", "measure.trendname", "type"];

// Regional settings
// See http://api.jqueryui.com/datepicker/ for details
var I18N_SETTINGS = {
	dateFormat: "d.m.yy",
	monthNames: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
	monthNamesShort: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
	dayNames: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
	dayNamesMin: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
	firstDay: 1,
	showWeek: true,
	weekHeader: "",
	showOtherMonths: true,
	changeMonth: true,
  changeYear: true,
	yearRange: "-10:+3"
};

// Some additional texts for the date filter dialog
var TRANSLATIONS = {
	"close": "OK",
	"from": "From",
	"to": "To",
	"clear": "Clear",
	"tooltip": "Add a quick filter" // shown when the user hovers over the filter icon
};

/*********************/
/* USER SETTINGS END */
/*********************/

var _activeDialog = null;

var ADD_ICON = "<#PortalImageFileLocation>filter_add_icon.png";
var REMOVE_ICON = "<#PortalImageFileLocation>filter_delete_icon.png";

function initializeQuickFilter() {
  if ($("#ResizableTableHead").attr("containsfilter") == "true") return;
  
  $(window).resize(function() {
    closeActiveDialog();
  });
  
  var textFilterDialog = '<div id="textFilterDialog" style="text-align: center; display: inline-block; height: \'auto\'" title="Filter column"><input id="quickfilter_text" type=\"text\" size="40" value=\"\"></input></div>';
  var datetextFilterDialog = '<div style="display:flex;justify-content:center;align-items:center" id="dateFilterDialog">' +
  '<label>' + TRANSLATIONS['from'] + ': </label><input id="quickfilter_from" type=\"text\" size="8" value="" style="margin: 0 5px 0 5px"></input>' + 
  '<label>' + TRANSLATIONS['to'] + ': </label><input id="quickfilter_to" type=\"text\" size="8" value="" style="margin: 0 8px 0 5px"></input>' + 
	'<a href="#" style="color: blue" id="btnClearDates">' + TRANSLATIONS['clear'] + '</a>&nbsp;&nbsp;' + 
	'<a href="#" style="color: blue" id="btnCloseDialog" onClick="closeActiveDialog()">' + TRANSLATIONS['close'] + '</a></div>';
	
  $("#ResizableTableHead").append(textFilterDialog).append(datetextFilterDialog);
  
  $( function() {
	  
    $("#textFilterDialog").dialog({
      autoOpen: false,
			autoResize: true,
			minHeight: 0,
			minWidth: 0,
			width: 'auto'
		});
		$("#dateFilterDialog").dialog({
      autoOpen: false,
			autoResize: true,
			minHeight: 0,
			minWidth: 0,
			width: 'auto'
		});
  });
  
  var selector = "";
  if ($("#ResizableTableHead th > div").length > 0) { //some headers uses div, some don't
    selector = " > div";
  }
  
  $("#ResizableTableHead th" + selector).each(function(index) {
		var sortField = $(this).children("a").attr("href");
		
		if (sortField != null && sortField.indexOf("'") > -1) {
			sortField = sortField.substring(sortField.indexOf("'") + 1);
			sortField = sortField.substring(0, sortField.indexOf("'")).toLowerCase();
		}
		if ($.inArray(sortField, BLACKLIST_FIELDS) != -1) {
			return;
		}
		var filter = {
			type: 'text',
			column: index,
			filterText: '',
			filterFrom: null,
			filterTo: null,
		};
		if ($.inArray(sortField, DATE_FIELDS) != -1) {
			 filter.type = 'date';
		}
		else {
			 filter.type = 'text';
		}
		var filterImg = $("<img class=\"quickfiltericon\" alt=\"" + TRANSLATIONS['tooltip'] + "\" title=\"" + TRANSLATIONS['tooltip'] + "\" src=\"" + ADD_ICON + "\"></img>"+
		"<img src=\"" + REMOVE_ICON + "\" style=\"display: none\">");
		filterImg.data("filterData", filter);
		$(this).append(filterImg);
  });
	
  $("#ResizableTableHead").attr("containsfilter", "true");
  $("#ResizableTableHead .quickfiltericon").click(filterIconClicked);

  $("#quickfilter_from, #quickfilter_to").datepicker(I18N_SETTINGS);
	
	// Fix column widths, otherwise they get messed up when hiding rows
	var columnWidths = new Array();
  $("#ResizableTableBody > tbody > tr:first > td").each(function() {
    columnWidths.push($(this).attr("style"));
  });

  $("#ResizableTableBody > tbody > tr").each(function() {
    var index = 0;
    $(this).children().each(function() {
	  if (columnWidths[index] != null) $(this).attr("style", columnWidths[index]);
	  index++;
	});
  });
}
	
function closeActiveDialog() {
	if (_activeDialog == null) {
		return;
	}
	var filter = $.data(_activeDialog, "filterData");
	var dialog = "#" + filter.type + "FilterDialog"; // #texttextFilterDialog or #datetextFilterDialog
	
	// Update icon based on whether the filter is active or not
	var bFilterActive = filter.type == "text" ? (filter.filterText.length > 0) : (filter.filterFrom || filter.filterTo);
	$(_activeDialog).attr("src", bFilterActive ? REMOVE_ICON : ADD_ICON);	
	
	$("#quickfilter_text").unbind(); // remove keyup listener
	$(dialog).dialog("close");
	_activeDialog = null;
}

function filterIconClicked(e) {
	
	// close possibly existing dialog
	if (_activeDialog != null) {
		// return if the user clicked the same filter icon again
		if (_activeDialog == e.target) {
			closeActiveDialog();
			return;
		} else {
			closeActiveDialog();
		}
	}	
	
	// open new dialog
	_activeDialog = e.target;
	
	var filter = $.data(e.target, "filterData");
	var dialog = "#" + filter.type + "FilterDialog";
	
	$(dialog).dialog( "option", "position", { my: "left center", at: "right center", of: e.target } );
	
	if (filter.type == "text") {
		$(dialog + " #quickfilter_text").val(filter.filterText);
		$(dialog + " #quickfilter_text").focus();
		$(dialog + " #quickfilter_text").focusout(function(el) {
			if ($(_activeDialog).is(":hover")) {
				return;
			}
			closeActiveDialog();

		});
		$("#quickfilter_text").keyup(e.target, function(e) {
			if (e.keyCode == 13) { // enter
				closeActiveDialog();
				return;
			}
			var filter = $.data(e.data, "filterData");
			
			filter.filterText = $(e.target).val().toLowerCase();
			$.data(e.data, "filterData", filter);
		
			applyFilters();
		});
	} 
	else if (filter.type == "date") 
	{
		$(dialog + " #quickfilter_from").datepicker('setDate', filter.filterFrom);
		$(dialog + " #quickfilter_to").datepicker('setDate', filter.filterTo);
		$("#dateFilterDialog #quickfilter_from, #dateFilterDialog #quickfilter_to").change(e.target, function(e) {
			var filter = $.data(e.data, "filterData");
			
			filter.filterFrom = $("#quickfilter_from").datepicker("getDate");
			filter.filterTo = $("#quickfilter_to").datepicker("getDate");
			$.data(e.data, "filterData", filter);

			applyFilters();
		});
		$("#btnClearDates").click(e.target, function(e) {
			$("#quickfilter_from").datepicker('setDate', null);
			$("#quickfilter_to").datepicker('setDate', null);
			var filter = $.data(e.data, "filterData");
			
			filter.filterFrom = null;
			filter.filterTo = null;
			$.data(e.data, "filterData", filter);
			closeActiveDialog();
			applyFilters();
		});
			
	} 
	else 
	{
		console.log("Unknown filter type!");
		return;
	}
	$(".ui-dialog-titlebar").hide();
	$(dialog).dialog("open");
	
}

function applyFilters() {
	//console.time('applyFilters');
	var activeFilters = [];

	// collect active filters stored in the filter icons
	$(".quickfiltericon").each( function(i, e) {
		var filter = $(this).data("filterData");
		
		if (filter.filterText.length > 0 || filter.filterFrom != null || filter.filterTo != null) {
			activeFilters[filter.column] = filter;
		}
	});
	
	$("#ResizableTableBody > tbody > tr").each(function(row) { //loop table rows

		$(this)[0].style.display = "";
		$(this).children().each(function(index) { //loop columns
			if (activeFilters[index] === undefined) {
				return true;
			}
			if (activeFilters[index].type == "text") {
				if ($(this).text().toLowerCase().indexOf(activeFilters[index].filterText) == -1) {
					$(this).parent()[0].style.display = "none";
					return false; // break loop
				}
			} 
			else if (activeFilters[index].type == "date") {
				var contentAsDate = $(this).text();
				contentAsDate = $.datepicker.parseDate(I18N_SETTINGS.dateFormat, contentAsDate);

				if ((activeFilters[index].filterFrom != null && (contentAsDate == null || contentAsDate < activeFilters[index].filterFrom)) || 
				    (activeFilters[index].filterTo != null && (contentAsDate == null || contentAsDate > activeFilters[index].filterTo))) {
					$(this).parent()[0].style.display = "none";
					return false;
				}
			}
			
		});
	});
  AdjustTable();
	//console.timeEnd('applyFilters');
}

</script>

<!-- [QPRTemplateEnd: quickfilter.tpl] -->